using System.Runtime.InteropServices;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Kav
{
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct GBufferInstanceVertex : IVertexType, IHasWorldMatrix
    {
        VertexDeclaration IVertexType.VertexDeclaration
        {
            get
            {
                return VertexDeclarations.GBufferInstanceDeclaration;
            }
        }

        public Matrix World { get; set; }

        public static readonly VertexDeclaration VertexDeclaration;

        public GBufferInstanceVertex(
            Matrix world
        ) {
            World = world;
        }
    }
}
